; Door Routines

; de = first byte, bc = second byte
OpenDoor:
 push de
 push bc
 ld a,(de)
 cp LOCKED_START
 jr c,OpenDoorNext
 cp LOCKED_END+1
 jr nc,OpenDoorNext
 ld b,a
 ld hl,PlayerKeys
 ld a,(hl)
 or a
 jr z,OpenDoorNeedKey 
 dec (hl)
 ld a,b
 ld b,d
 ld c,e
 jr OpenDoorFound
OpenDoorNext:
 ld a,(bc)
 cp LOCKED_START
 jr c,OpenDoorDone
 cp LOCKED_END+1
 jr nc,OpenDoorDone
 ld d,a
 ld hl,PlayerKeys
 ld a,(hl)
 or a
 jr z,OpenDoorNeedKey 
 dec (hl)
 ld a,d
OpenDoorFound:
 sub LOCKED_START-UNLOCKED_START
 ld (bc),a
 ld (RedrawMap),a
 ld h,b
 ld l,c
 ld de,$10000-Map
 add hl,de
 ld c,l
 ld d,a
 ld a,(CurrMap)
 ld b,a
 ld a,d
 call AddToChangeList  
OpenDoorDone:
 pop bc
 pop de
 ret
OpenDoorNeedKey:
 ld a,9
 call PrintString
 jr OpenDoorDone

.end
